{g-vars.i &vsh = "shared"}
{show-header-frame-def.i}

screen-title = "Room Management".

def buffer b-room2 for room.
def buffer b-room-state2 for room-state.

def new shared var current-floor-no as int init 1.
def var selection as char init ?.
def var sprog as char init ?.

def var is-ok as log.
def var c-room as recid.

find first room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
c-room = (if avail(room) then recid(room) else ?).

def var r-floor like room.floor.
def var r-no like room.room-number.
def var r-type like room.type-of-room.
def var r-state like room-state.state init yes.
def var r-state-date like room-state.start-date.

form r-floor
     skip
     r-no
     skip
     r-type format ">>>,>>>,>>>" view-as combo-box inner-lines 5  label "Room type"
     skip
     r-state-date
     skip
     r-state 
       with frame f-room side-labels size 80 by 20 at row 2 col 1.

run set-room-types-combo (input r-type:handle in frame f-room).

view frame f-room.

procedure refresh.
   def buffer b-room for room.
   if c-room = ? then do:
      clear frame f-room all no-pause.
      return.
   end.
   
   find b-room where recid(b-room) = c-room no-lock.
   r-floor = b-room.floor.
   r-no = b-room.room-number.
   r-type = b-room.type-of-room.
   
   /* find room state*/
   find last room-state where room-state.room-number = b-room.room-number and room-state.start-date <= today no-lock no-error.
   if avail room-state then do:
      r-state-date = room-state.start-date.
      r-state = room-state.state.
   end.
   else do:
      r-state-date = today.
      r-state = yes.
   end.
   
   display r-floor r-no r-type r-state r-state-date with frame f-room.
end.

run refresh.

PROC:
repeat:
   {show-header.i}
   
   sprog = ?.
   case selection:
      when "P" then do:
         find prev room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
         if avail room then do:
            c-room = recid(room).
            run refresh.
         end.
      end.
      when "N" then do:
         find next room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
         if avail room then do:
            c-room = recid(room).
            run refresh.
         end.
      end.
      when "F" then do:
         find first room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
         if avail room then do:
            c-room = recid(room).
            run refresh.
         end.
      end.
      when "L" then do:
         find last room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
         if avail room then do:
            c-room = recid(room).
            run refresh.
         end.
      end.
      when "I" then do:
         def var r-no2 as int.
         do on endkey undo, leave:
            update r-no2 label "Room number" validate(can-find(first room where room.room-number = r-no2), "Room number doesn't exist!")
                   with frame f-find overlay centered side-labels title "Find Room by Number".
         end.
         hide frame f-find no-pause.

         find room where room.room-number = r-no2 no-lock no-error.
         if avail room then do:
            c-room = recid(room).
            current-floor-no = room.floor.
            run refresh.
         end.
      end.
      when "D" then do:
         if c-room <> ? then do:
            find b-room2 where recid(b-room2) = c-room.
            
            find b-room-state2 where b-room-state2.room = b-room2.room-number no-lock no-error.
            if avail b-room-state2 and not b-room-state2.state
            then do:
               message "The room is already inactive" view-as alert-box.
            end.
            else do:
               message "Deactivate room starting with" today "?" update is-ok view-as alert-box buttons yes-no.
               if is-ok then do:
                  if avail b-room-state2 and b-room-state2.start-date = today 
                  then do transaction:
                     find current b-room-state2 exclusive-lock.
                     b-room-state2.state = no.
                  end.
                  else do transaction:
                     create b-room-state2.
                     b-room-state2.room-number = b-room2.room-number.
                     b-room-state2.state = no.
                     b-room-state2.start-date = today.
                  end.
               end. 
            end.
         end.
         run refresh.
      end.
      when "A" then do:
         release b-room2.
         if c-room <> ? then do:
            find b-room2 where recid(b-room2) = c-room.
            
            find  b-room-state2 where b-room-state2.room = b-room2.room-number no-lock no-error.
            if avail b-room-state2 and b-room-state2.state
            then do:
               message "The room is already active" view-as alert-box.
            end.
            else do:
               message "Activate room starting with" today "?" update is-ok view-as alert-box buttons yes-no.
               if is-ok then do:
                  if avail b-room-state2 and b-room-state2.start-date = today 
                  then do transaction:
                     find current b-room-state2 exclusive-lock.
                     b-room-state2.state = yes.
                  end.
                  else do transaction:
                     create b-room-state2.
                     b-room-state2.room-number = b-room2.room-number.
                     b-room-state2.state = yes.
                     b-room-state2.start-date = today.
                  end.
               end. 
            end.
         end.
         run refresh.
      end.
      when "S" then do:
         {set_floor_number.i}
         find first room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
         if not avail room then do:
            c-room = ?.
            message "No more rooms".
         end.
         else do:
            c-room = recid(room).
         end.
         run refresh.
      end.
      when "O" then sprog = "rooms-overview.p".
      when "M" then do:
         run rooms-add.p.
         find first room where room.floor = current-floor-no no-lock use-index idx-r-no no-error.
         if avail room then do:
            c-room = recid(room).
            run refresh.
         end.
      end.
      when "R" then do:
         publish "pop-program".
         leave PROC.
      end.
      when "U" then do:
         if c-room <> ? then do transaction:
            update r-type with frame f-room.
            find b-room2 where recid(b-room2) = c-room exclusive-lock.
            b-room2.type-of-room = r-type.
         end.
      end.
      otherwise do:
         if selection <> ? then do:
            message "Invalid selection - try again".
            selection = ?.
            pause.
            next. 
         end.
      end.
   end.

   if sprog <> ? then leave PROC.

   {wait-selection.i
      &sele1="(P)rev   (N)ext   (F)irst   (L)ast   (D)eactivate   (A)ctivate"
      &sele2="(S)et Floor No   F(i)nd   (O)verview   Add Roo(m)s   (U)pdate   "
      }
end.

if sprog <> ? then do:
   publish "push-program" (sprog).
end.
