@echo off

setlocal enableextensions enabledelayedexpansion

:: standard P2J interactive client startup script

:: defaults
set cfgdir=%~dp0
set up=../../../..
set /A debug=0
set suspend=n
set prog=java
set dump=-XX:+HeapDumpOnOutOfMemoryError
:: dump=-XX:+HeapDumpOnOutOfMemoryError -XX:OnOutOfMemoryError='./stack_dump.sh %p'
:: set swing=client:driver:type=chui_swing client:chui:rows=24 client:chui:columns=80 client:chui:background=0x000000 client:chui:foreground=0xFFA500 client:chui:selection=0x0000FF client:chui:fontname=monospaced client:chui:fontsize=12
set host=net:server:host=localhost
set cfg=
set logdir=%P2J_LOG_DIR%
set log=
set srvr=
set test=n
set /A instance=0
set /A portbase=3333
set /A portstep=100

:: help text
set usage[0]=Usage: %0 [-d port] [-s] [-t] [-l logfile] [-c cfgfile] [-i instance] [-2]
set usage[1]=Where:
set usage[2]=-d         = enable JVM debug mode, use the specified TCP port
set usage[3]=-s         = in JVM debug mode enable, suspend the JVM on startup (does not suspend by default)
set usage[4]=-t         = test mode (displays the command but doesn't execute)
set usage[5]=-l         = log file name in your home dir (all STDERR is redirected to this file, defaults to stderr.log)
set usage[6]=-h         = hostname or IP address for the server (defaults to localhost)
set usage[7]=-i         = server instance number (0..9, assigns the P2J server port, defaults to 0) to which to connect
set usage[8]=-c         = config file name (P2J bootstrap config file name)
set usage[9]=-2         = enable C2 HotSpot compiler (server compiler for the JVM)
:: set usage[10]=-z         = specify the path (with no trailing slash) to the location of the p2j.jar, libTerminal.so and libp2j.so

set argCount=0
for %%x in (%*) do (
   set /A argCount=!argCount!+1
   set "argVec[!argCount!]=%%~x"
)

set remainder=
set /a i=1
:while1
   set carg=!argVec[%i%]!

   if "%carg%" equ "-d" (
      set /A "i=i+1"
      call :setvar dport !i!
      set /A debug=1
   ) else if "%carg%" equ "-s" (
      set suspend=y
   ) else if "%carg%" equ "-t" (
      set prog=echo %prog%
      set test=y
   ) else if "%carg%" equ "-l" (
      set /A "i=i+1"
      call :setvar log !i!
   ) else if "%carg%" equ "-h" (
      set /A "i=i+1"
      call :setvar host !i!
      set /A host=!host!
      set host=net:server:host=!host!
   ) else if "%carg%" equ "-i" (
      set /A "i=i+1"
      call :setvar instance !i!
      set /A instance=!instance!
   ) else if "%carg%" equ "-c" (
      set /A "i=i+1"
      call :setvar cfg !i!
   ) else if "%carg%" equ "-2" (
      set srvr=-server
   ) else if "%carg%" equ "-u" (
      set up=%up%\%up%
   ) else if "%carg%" equ "help" (
      for /L %%a in (0,1,9) do call echo.%%usage[%%a]%%
      goto:eof
   ) else (
      set remainder=%remainder% !carg!
   )
   set /a i=%i%+1
   if %i% leq %argCount% ( goto :while1 )

:: final arg prep
set /A sport=(%portbase% + %instance%)
set /A iport=(%portbase% + %instance% + %portstep%)
set iport=net:server:insecure_port=%iport%
set port=net:connection:secure=false net:server:secure_port=%sport% %iport%

if %debug% equ 1 ( set dtxt=-Xdebug -Xnoagent -Djava.compiler=NONE -Xrunjdwp:transport=dt_socket,address=%dport%,server=y,suspend=%suspend% ) else ( set dtxt= )
if "%log%" equ "" (
   if "%logdir%" equ "" ( set logdir=.)
   call :getPID pid
   set log=!logdir!\client_%USERNAME%_!pid!.log
)

if "%cfg%" neq "" (
   set cfg=%cfgdir%%cfg%
)
set lpath=-Djava.library.path=../lib/
set cpath=-classpath ../lib/p2j.jar;

set cmd=CMD.EXE /C %prog% %srvr% %dump% %dtxt% %lpath% %cpath% com.goldencode.p2j.main.ClientDriver %host% %port% %swing% %cfg% %remainder%
if "%test%" equ "y" (
   %cmd%
) else (
   %cmd% 2> %log%
)

endlocal
goto:eof

:setvar
set k=%2
set %1=!argVec[%k%]!
goto:eof

:getPID  [RtnVar]
::
:: Store the Process ID (PID) of the currently running script in environment variable RtnVar.
:: If called without any argument, then simply write the PID to stdout.
::
setlocal disableDelayedExpansion
:getLock
set "lock=%temp%\%~nx0.%time::=.%.lock"
set "uid=%lock:\=:b%"
set "uid=%uid:,=:c%"
set "uid=%uid:'=:q%"
set "uid=%uid:_=:u%"
setlocal enableDelayedExpansion
set "uid=!uid:%%=:p!"
endlocal & set "uid=%uid%"
2>nul ( 9>"%lock%" (
  for /f "skip=1" %%A in (
    'wmic process where "name='cmd.exe' and CommandLine like '%%<%uid%>%%'" get ParentProcessID'
  ) do for %%B in (%%A) do set "PID=%%B"
  (call )
))||goto :getLock
del "%lock%" 2>nul
endlocal & if "%~1" equ "" (echo(%PID%) else set "%~1=%PID%"
exit /b
